/*
 * This source file is part of KEOS (Free 3D Engine)
 * For the latest info, see http://www.keosengine.org/
 * E-mails : thierry.vouriot@keosengine.org, yeri@keosengine.org
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA, or go to
 * http://www.gnu.org/copyleft/lesser.txt.
 *
 */

#include "KeosMediaManager.h"
#include "KeosLogger.h"

namespace Keos
{
    //=======================================================================
    // CMediaManager implementation
    //=======================================================================

    //-----------------------------------------------------------------------
    CMediaManager::CMediaManager()
    {
        ILogger::Log("--> Create MediaManager");
        m_Paths.insert("");
    }

    //-----------------------------------------------------------------------
    CMediaManager::~CMediaManager()
    {
        ILogger::Log("<-- Destroy MediaManager");
    }
    
    //-----------------------------------------------------------------------
    void CMediaManager::AddSearchPath(const String& strPath)
    {
        if (strPath.empty() || (*strPath.rbegin() == '\\') || (*strPath.rbegin() == '/'))
            m_Paths.insert(strPath);
        else
            m_Paths.insert(strPath + "\\");
    }

    //-----------------------------------------------------------------------
    CFile CMediaManager::FindMedia(const CFile& Filename) const
    {
        for (std::set<String>::const_iterator i = m_Paths.begin(); i != m_Paths.end(); ++i)
        {
            CFile RetFile = *i + Filename.Fullname();
            if (RetFile.Exists())
                return RetFile;
        }

        LOADINGFAILED_EXCEPT(Filename.Fullname(), "File not found in the research directories","CMediaManager::FindMedia");
    }

} // namespace Keos

